<template>
  <div>
    <!-- <div class="hanson-bar">
      <span>当前筛选条件下共{{page.total || '--'}}资产</span>
      <div style="width:300px;float:right;overflow:hidden;">
        <el-button size="small" @click="addDevice" icon="iconfont icon-tianjia">添加资产</el-button>
        <el-button size="small" @click="reset" icon="iconfont icon-shuaxin">刷新</el-button>
        <el-button size="small" @click="undo" icon="iconfont icon-undo">撤销</el-button>
      </div>
    </div>-->
    <div class="hanson-bar">
      <span>当前筛选条件下共{{page.total || '--'}}资产</span>
      <div style="width:300px;float:right;overflow:hidden;">
        <el-button size="small" @click="addDevice" icon="iconfont icon-tianjia">添加资产</el-button>
        <el-button size="small" @click="reset" icon="iconfont icon-shuaxin">刷新</el-button>
        <el-button size="small" @click="undo" icon="iconfont icon-undo">撤销</el-button>
      </div>
      <div style="width:200px;color:gray;float:right;padding-top:7px;font-size:10px;">
        <span v-if="!onlyRead">隐藏自动填充的信息点:</span>
        <el-tooltip v-if="!onlyRead" :content="'' + (isWatch ? '隐藏' : '不隐藏')" placement="top">
          <el-switch
            @change="changeWatch"
            v-model="isWatch"
            active-color="#13ce66"
            inactive-color="gray"
          ></el-switch>
        </el-tooltip>
        <span v-if="onlyRead">只看要采集的信息:</span>
        <el-tooltip v-if="onlyRead" :content="'' + (allMess ? '部分' : '全集')" placement="top">
          <el-switch
            @change="changeWatch"
            v-model="allMess"
            active-color="#13ce66"
            inactive-color="gray"
          ></el-switch>
        </el-tooltip>
      </div>
      <div
        style="width:90px;cursor: pointer;color:gray;float:right; font-size:10px;padding-top:7px;"
      >
        <p v-if="onlyRead" @click="changeRead">
          <i class="iconfont icon-yulan"></i>
          <span>只读模式</span>
        </p>
        <p v-else @click="changeRead">
          <i class="iconfont icon-yulan"></i>
          <span>编辑模式</span>
        </p>
      </div>
    </div>
    <qrcode :qrcodeUrl="qrcodeUrl" :dialog="dialog" :addBody="true" ref="qrcode"></qrcode>
    <firm ref="firm" :mess="mess" @changeFirm="firmChange" :dialog="dialog"></firm>
    <supply-dialog @change="supplyChange" ref="supply" :id="id" :dialog="dialog"></supply-dialog>
    <supplier-dialog ref="supplier" @changeSupplier="supplierChange" :dialog="dialog"></supplier-dialog>
    <guarantee-dialog @change="guaranteeChange" :id="id" ref="guarantee" :dialog="dialog"></guarantee-dialog>
    <upload-files-dialog
      :read="onlyRead ? true : false"
      ref="upload"
      @changeFile="fileChange"
      :keysArr="filesArr"
      :dialog="dialog"
    ></upload-files-dialog>
    <upload-img-dialog
      :read="onlyRead ? true : false"
      @changeFile="imgChange"
      :keysArr="imgsArr"
      :dialog="dialog"
    ></upload-img-dialog>
    <maintainer-dialog @changeMaintainer="changeMaintainer" ref="maintainer" :dialog="dialog"></maintainer-dialog>
    <insurer-dialog @changeInsurer="changeInsurer" ref="insurer" :dialog="dialog"></insurer-dialog>
    <pic-dialog
      :read="onlyRead ? true : false"
      :dialog="dialog"
      :keysArr="picsArr"
      @change="changePics"
    ></pic-dialog>
    <div
      v-show="!main || !main.length"
      style="width:100%;text-align:center;font-size:30px;color:gray;"
    >请选择设备族</div>
    <div v-show="main && main.length" v-loading="loading" id="handsontable" ref="handsontable"></div>
    <my-pagination v-show="main && main.length" @change="getMain" :page="page"></my-pagination>
    <dialog-assets
      :assetType="[this.mess.deviceId]"
      @close="closeDialog"
      ref="assets"
      v-if="dialog.addDevice"
      :dialog="dialog"
    ></dialog-assets>
    <details-dialog :iframeSrc="iframeSrc" v-if="dialog.details" :dialog="dialog"></details-dialog>
    <look-pic :dialog="dialog" :keysArr="picsArr"></look-pic>
  </div>
</template>
<script>
import { getTableHeader, getBillPropList, updateProperty, upDateTableMain, delProperty, getEquipmentFamily } from "@/api/request";


import tools from "@/assets/js/tools";
import handsonUtils from "@/utils/hasontableUtils"
import text from "@/utils/hansontable/mainText"

import qrcode from "@/components/lib/qrcode";
import firm from "@/components/dialogs/list/firm";
import supplyDialog from "@/components/dialogs/list/supplyDialog";
import supplierDialog from "@/components/dialogs/list/supplierDialog";
import maintainerDialog from "@/components/dialogs/list/maintainerDialog";
import insurerDialog from "@/components/dialogs/list/insurerDialog";
import guaranteeDialog from "@/components/dialogs/list/guaranteeDialog";
import uploadFilesDialog from "@/components/dialogs/list/filesDialog";
import uploadImgDialog from "@/components/dialogs/list/uploadImgDialog";
import picDialog from "@/components/dialogs/list/picDialog"
import myPagination from "@/components/lib/myPagination";
import dialogAssets from "@/components/dialogs/addDialog/dialogAssets";
import detailsDialog from "@/components/lib/detailsDia"

//图片查看
import lookPic from "@/components/lib/lookImages"

//下拉插件
import "@/assets/js/chosen.jquery.min";
import "@/assets/js/handsontable-chosen-editor";

import showTools from "@/utils/hansontable/notShow"

export default {
  components: {
    qrcode, //二维码页面
    firm, //
    supplyDialog,
    supplierDialog,
    guaranteeDialog,
    uploadFilesDialog,
    maintainerDialog,
    insurerDialog,
    uploadImgDialog,
    picDialog,
    myPagination,
    dialogAssets,
    detailsDialog,
    lookPic
  },
  data() {
    return {
      main: [],
      mess: {},
      headers: null,
      page: {
        size: 50,
        sizes: [10, 30, 50, 100, 150, 200],
        total: 0,
        currentPage: 1
      },
      dialog: {
        qrcode: false, //二维码弹窗
        firm: false, //厂商弹窗
        supply: false, //选择供应合同
        supplier: false, //供应商选择
        guarantee: false, //选择保单
        maintainer: false, //选择维修商
        insurer: false, //选择保险公司
        uploadFiles: false,//上传文件
        uploadImgs: false,//上传单个图片
        pic: false, //多个图片
        addDevice: false,
        details: false,//详情页
        lookPic: false,//图片查看
      },
      row: null,//被修改的row
      filesArr: [],//保存临时的文件key
      messKey: null,
      imgsArr: [],//临时保存的图片key数组
      picsArr: [],//临时设备图片keys数组
      projId: this.$route.query.projId,
      copyMain: null,
      groupList: [],
      iframeSrc: "",
      id: "",
      isWatch: true,
      category: {},
      onlyRead: true,
      allMess: true,
      linkNameFalg: false,
      qrcodeUrl: "",//二维码图片地址
      loading: false
    };
  },
  created() {
  },
  mounted() { },
  methods: {
    changeRead() {
      this.onlyRead = !this.onlyRead
      console.log(this.onlyRead)
      this.getMain()
    },
    //获取表头
    getHeaderData(code) {
      this.mess = code
      this.page.size = 10
      this.page.currentPage = 1
      this.getEquipGroup()
    },

    getEquipGroup() {
      getEquipmentFamily(res => {
        res.Content.map(item => {
          if (item.content && item.content.length) {
            item.content.map(key => [
              this.groupList.push(key)
            ])
          }
        })
        this.getMyHeader()
      })
    },

    getMyHeader() {
      getTableHeader({
        code: this.mess.deviceId,
        ProjId: this.projId
      }).then(res => {
        this.headers = res.data.Content;
        this.getMain()
      });
    },

    //switch改变
    changeWatch() {
      this.reset()
    },

    //获取主体数据
    getMain() {
      let _this = this
      this.loading = true
      let param = {
        data: {
          customInfo: true,
          "limit": {        // 分页查询, 选填.
            "skip": this.page.size * (this.page.currentPage - 1),  // 跳过多少数据
            "count": this.page.size   // 查询跳过300条数据之后的50条 (默认按照创建时间从大-->小排序)
          },
          criteria: {
            id: "",
            family: [this.mess.deviceId]
          }
        },
        secret: this.$route.query.secret,
        ProjId: this.$route.query.projId
      }
      if (this.mess.buildId == "all") {
        delete param.data.criteria.id
      } else if (this.mess.floorId && this.mess.floorId != "all") {
        param.data.criteria.id = this.mess.floorId
      } else if (this.mess.floorId == 'all') {
        param.data.criteria.id = this.mess.buildId
      } else {
        param.data.criteria.id = this.mess.ProjId
      }
      getBillPropList(param, res => {
        if (res.Content.length) {
          let list = []
          res.Content = res.Content.map(item => {
            item.assetsName = item.linkEquipLocalName || item.linkEquipName
            if (!!item.linkCategory) {
              this.groupList.map(child => {
                if (item.linkCategory.substring(2, 6) == child.code) {
                  item.linkCategory = child.name
                }
              })
            }
            if (!!item.infos.DPManufacturerID) {
              item.infos.DPManufacturerID = item.infos.DPManufacturerID + "-" + item.infos.Brand + "/" + item.infos.Specification
            }
            if (!!item.infos.DPSupplierID) {
              item.infos.DPSupplierID = item.infos.DPSupplierID + "-" + item.infos.Supplier
            }
            if (!!item.infos.DPMaintainerID) {
              item.infos.DPMaintainerID = item.infos.DPMaintainerID + "-" + item.infos.Maintainer
            }
            if (!!item.infos.DPInsurerID) {
              item.infos.DPInsurerID = item.infos.DPInsurerID + "-" + item.infos.Insurer
            }
            if (!!item.infos.ServiceLife && !!!item.infos.ExpectScrapDate) {
              item.infos.ExpectScrapDate = tools.dateAddYear(new Date(), item.infos.ServiceLife)
              list.push(item)
            }
            return item
          })
          if (list.length) {
            _this.updateScrapDate(list)
          }
          _this.main = res.Content
          _this.copyMain = tools.deepCopy(res.Content)
          _this.page.total = res.Count
          if (!!_this.hot) {
            _this.hot.destroy();
            _this.hot = null;
          }
          if (!!res.Content && res.Content.length) {
            _this.initHot();
          }
        }
        this.loading = false
      })
    },

    updateScrapDate(data) {
      let param = data.map(item => {
        return {
          FmId: item.id,
          Infos: {
            ExpectScrapDate: item.infos.ExpectScrapDate
          }
        }
      })
      upDateTableMain({
        ProjId: this.$route.query.projId,
        UserId: this.$route.query.userId
      }, param).then(res => {
        if (res.data.Result == "success") {
          return
        } else {
          this.$message.error("添加报废日期错误")
        }
      })
    },

    //获取动态参数
    getBatch(data) {
      console.log(this.headers, data, "data22222")
      let param = {
        secret: this.$route.query.secret,
        ProjId: this.$route.query.projId,
        data: {
          criterias: []
        }
      }
      //   if (!!data && data.length) {
      //     //一级遍历list
      //     data.map(item => {
      //       if (!!item.infos) {
      //         //二级遍历对象infos
      //         for (let key in item.infos) {
      //           //判断是否是设定参数和动态参数
      //           if (!!item.infos[key]) {
      //             this.headers.map(child => {
      //               //如果一级标签为动态参数或者设定参数放入数据等待请求
      //               if (key == child.infoPointCode && (child.firstTag == "运行参数" || child.firstTag == "设定参数")) {
      //                 param.data.criterias.push({
      //                   id: item.id,
      //                   code: key
      //                 })
      //               }
      //             })
      //           }
      //         }
      //       }
      //     })
      //     if (param.data.criterias.length) {
      //       BeatchQueryParam(param, res => {
      //         this.main = data.map(item => {
      //           res.Content.map(child => {
      //             if (item.id == child.id) {
      //               if (!!child.data) {
      //                 item.infos[child.code] = child.data
      //               } else {
      //                 item.infos[child.code] = child.error ? child.error : "无实时数值"
      //               }
      //             }
      //           })
      //           return item
      //         })
      //         console.log(this.main)
      //         this.hot.loadData(this.main)
      //       })
      //     }
      //   }
    },

    //撤回
    undo() {
      this.hot.undo();
    },

    //刷新
    reset() {
      this.getMain();
    },

    //添加设备
    addDevice() {
      this.dialog.addDevice = true
      this.$nextTick(() => {
        this.$refs.assets.step(0)
        this.$refs.assets.setValue([this.mess.deviceId])
      })
    },

    /**
     * 表头文案处理函数
     * @param arr header数组数据
     *
     * @return 处理好的文案
     */
    delHeader(list) {
      let arr = tools.copyArr(list)
      // 如果不是只读状态，添加四大厂商选择
      let readArr = ["A1", "A2", "B1", "C5", "D1", "D2", "X", "L", "L1", "L2", "F1", "F2", "M"]
      if (!this.onlyRead) {
        arr = showTools.arrToArr(arr)
        readArr.push("Own")
      }
      let data = showTools.changeHeader(arr, readArr, this.onlyRead, this.isWatch, this.allMess, true)
      data.unshift("操作", "当前关联的设备");
      console.log("header", data)
      return data;
    },

    /**
     * 表头数据处理函数
     * @param list header数组数据
     *
     * @return 处理好的数据格式
     */
    getType(list) {
      let arr = tools.copyArr(list)
      // 如果不是只读状态，添加四大厂商选择
      if (!this.onlyRead) {
        arr = showTools.arrToArr(arr)
      }
      let data = showTools.showTypes(arr, this.onlyRead, this.isWatch, this.allMess, true)
      data.unshift(
        {
          data: "caozuo",
          renderer: tools.lookDetails
        }, {
          data: "assetsName",
          readOnly: true
        }
      );
      if (!this.onlyRead) {
      } else {
        data.map(item => {
          item.readOnly = true
        })
      }
      data.map(item => {
        if (
          item.data == "infos." + "Drawing" ||
          item.data == "infos." + "Pic" ||
          item.data == "infos." + "Nameplate" ||
          item.data == "infos." + "InstallPic" ||
          item.data == "infos." + "InstallDrawing"
        ) {
          item.renderer = text.picType
        }
        if (item.data == "infos." + "Archive" ||
          item.data == "infos." + "CheckReport" ||
          item.data == "infos." + "InsuranceFile") {
          item.renderer = text.fileType
        }
      })
      console.log("type", data)
      return data;
    },

    messShow(item) {
      //二维码
      if (item.infopoint_code == "EquipQRCode") {
        return {
          data: "infos." + item.infopoint_code,
          renderer: text.lookQRCode,
          readOnly: true
        }
      }
      if (item.collection_cmpt_code == "Enum") {
        return {
          data: "infos." + item.infopoint_code,
          renderer: this.customDropdownRenderer,
          editor: "chosen",
          chosenOptions: {
            // multiple: true,//多选
            data: item.dataSource || ""
          }
        };
      } else if (item.collection_cmpt_code == "Num") {
        return {
          data: "infos." + item.infopoint_code,
          type: "numeric",
          numericFormat: {
            pattern: "0,0.00"
            // culture: 'de-DE' // use this for EUR (German),
            // more cultures available on http://numbrojs.com/languages.html
          }
        };
      } else if (item.collection_cmpt_code == "Time") {
        return {
          data: "infos." + item.infopoint_code,
          type: "date",
          dateFormat: "YYYY-MM-DD",
          correctFormat: true
        };
      } else if (item.collection_cmpt_code == "text") {
        return {
          data: "infos." + item.infopoint_code
        };
      } else if (
        (item.info_point_code == "设备ID" ||
          item.info_point_code == "设备名称")
      ) {
        return {
          data: "infos." + item.infopoint_code,
          readOnly: true
        };
      } else if (item.collection_cmpt_code == "checkBox") {
        return {
          data: "infos." + item.infopoint_code,
          renderer: this.customDropdownRenderer,
          editor: "chosen",
          chosenOptions: {
            multiple: true,//多选
            data: item.dataSource || ""
          }
        };
      } else {
        return {
          data: "infos." + item.infopoint_code,
        }
      }
    },

    changeItem(item) {
      //二维码
      if (item.infopoint_code == "EquipQRCode" && item.visible) {
        return {
          data: "infos." + item.infopoint_code,
          renderer: text.lookQRCode,
          readOnly: true
        }
      }
      //厂商选择
      //   if ((item.infopoint_code == "Brand" || item.infopoint_code == "Specification") && item.visible) {
      //     return {
      //       data: "infos." + item.infopoint_code,
      //       renderer: tools.lookDetails,
      //       readOnly: true
      //     }
      //   }

      //   if (item.infopoint_code == "SupplierContractID" && item.visible) {
      //     return {
      //       data: "infos." + item.infopoint_code,
      //       renderer: tools.lookDetails,
      //       readOnly: true
      //     }
      //   }

      if (item.infopoint_code == "InsuranceNum" && item.visible) {
        //选择保单
        return {
          data: "infos." + item.infopoint_code,
          renderer: tools.lookDetails,
          readOnly: true
        }
      }

      if ((item.infopoint_code == "InsuranceFile" || item.infopoint_code == "Archive") && item.visible) {
        return {
          data: "infos." + item.infopoint_code,
          renderer: tools.lookDetails,
          readOnly: true
        }
      }

      if (
        (
          item.infopoint_code == "InstallPic" ||
          item.infopoint_code == "InstallDrawing" ||
          item.infopoint_code == "Nameplate" ||
          item.infopoint_code == "Pic" ||
          item.infopoint_code == "Drawing"
        ) && item.visible
      ) {
        return {
          data: "infos." + item.infopoint_code,
          renderer: tools.lookDetails,
          readOnly: true
        }
      }

      if (
        (
          item.infopoint_code == "Maintainer" ||
          item.infopoint_code == "Supplier" ||
          item.infopoint_code == "Insurer" ||
          item.infopoint_code == "InsurerContactor"
        )
        && item.visible
      ) {
        return {
          data: "infos." + item.infopoint_code,
        }
      }

      if (item.collection_cmpt_code == "Enum" && item.visible) {
        return {
          data: "infos." + item.infopoint_code,
          renderer: this.customDropdownRenderer,
          editor: "chosen",
          chosenOptions: {
            // multiple: true,//多选
            data: item.dataSource || ""
          }
        };
      } else if (item.collection_cmpt_code == "Num" && item.visible) {
        return {
          data: "infos." + item.infopoint_code,
          type: "numeric",
          numericFormat: {
            pattern: "0,0.00"
            // culture: 'de-DE' // use this for EUR (German),
            // more cultures available on http://numbrojs.com/languages.html
          }
        };
      } else if (item.collection_cmpt_code == "Time" && item.visible) {
        return {
          data: "infos." + item.infopoint_code,
          type: "date",
          dateFormat: "YYYY-MM-DD",
          correctFormat: true
        };
      } else if (item.collection_cmpt_code == "text" && item.visible) {
        return {
          data: "infos." + item.infopoint_code
        };
      } else if (
        (item.info_point_code == "设备ID" ||
          item.info_point_code == "设备名称") && item.visible
      ) {
        return {
          data: "infos." + item.infopoint_code,
          readOnly: true
        };
      } else if (item.collection_cmpt_code == "checkBox" && item.visible) {
        return {
          data: "infos." + item.infopoint_code,
          renderer: this.customDropdownRenderer,
          editor: "chosen",
          chosenOptions: {
            multiple: true,//多选
            data: item.dataSource || ""
          }
        };
      } else if (item.collection_cmpt_code == "Own" && item.visible) {
        return {
          data: "infos." + item.infopoint_code,
          renderer: text.idType,
        }
      } else {
        return undefined
      }
    },

    //初始化插件
    initHot() {
      var container = document.getElementById("handsontable");
      let winHeight = document.documentElement.clientHeight;
      this.hot = new Handsontable(container, {
        data: this.main,
        fixedColumnsLeft: 5,
        colHeaders: this.delHeader(this.headers), //表头文案
        columns: this.getType(this.headers), //数据显示格式
        filters: true,
        maxRows: this.main.length,
        height: winHeight - 100 - 50 - 150,
        columnSorting: true, //添加排序
        sortIndicator: true, //添加排序
        renderAllRows: true,
        // colWidths: 200,
        autoColumnSize: true,
        language: "zh-CN",
        manualColumnResize: true,
        manualColumnMove: true,
        dropdownMenu: [
          "filter_by_condition",
          "filter_by_value",
          "filter_action_bar"
        ],
        contextMenu: {
          items: {
            remove_row: {
              name: "删除该资产"
            }
          }
        },
        // 事件
        afterChange: this.tdChange, //修改后
        afterFilter: this.trimmedRows, //排序前
        afterRemoveRow: this.romoveFm, //右键删除
        afterOnCellMouseDown: this.eventClick //鼠标点击
      });
      let pro = document.getElementById("hot-display-license-info");
      if (!!pro) {
        pro.parentNode.removeChild(pro);
      }
      this.isLoading = false;
    },

    //关闭
    closeDialog(val) {
      this.$emit("getJson", val)
    },

    //表格中的点击
    eventClick(el, rowArr) {
      //点击的是表头
      if (rowArr.row < 0) {
        return;
      }
      //被筛选过后的数组
      let trimmedArr = this.trimmedRows();
      //是否启用了排序
      let isSort = this.hot.getPlugin("columnSorting").isSorted();
      if (trimmedArr.length && isSort) {
        let sortArr = this.myHotArr.getPlugin("columnSorting").rowsMapper
          .__arrayMap;
        let infos = this.main[trimmedArr[sortArr[rowArr.row]]];
        this.getInfors(infos, { row: sortArr[rowArr.row], col: rowArr.col });
      } else if (isSort) {
        //排序后的数组
        let sortArr = this.hot.getPlugin("columnSorting").rowsMapper.__arrayMap;
        let infos = this.main[sortArr[rowArr.row]];
        this.getInfors(infos, { row: sortArr[rowArr.row], col: rowArr.col });
      } else if (trimmedArr.length) {
        let infos = this.main[trimmedArr[rowArr.row]];
        this.getInfors(infos, { row: trimmedArr[rowArr.row], col: rowArr.col });
      } else {
        let infos = this.main[rowArr.row];
        this.getInfors(infos, rowArr);
      }
    },

    tdChange(changeData, source) {
      if (!this.onlyRead) {
        if (changeData) {
          let trimmedArr = this.trimmedRows();
          let param = handsonUtils.getParam(changeData, source, this.hot, trimmedArr);
          let data = [];
          for (let i = 0; i < param.length; i++) {
            data.push(param[i]);
          }
          //如果data中包含/且data长度为1,将其转换成.
          if (changeData.length == 1 && changeData[0][1].indexOf("/") > 0) {
            changeData[0][1] = changeData[0][1].split("/").join(".")
          }

          //存在data进行修改请求
          if (data && data.length) {
            this.updateBusiness(data, changeData);
          }
        }
      }
    },

    //删除资产
    romoveFm() {
      console.log(this.main, this.copyMain)
      let params = tools.differenceArr(this.main, this.copyMain)
      console.log(params, "params")
      let _this = this
      let param = {
        secret: this.mess.secret,
        ProjId: this.mess.ProjId,
        data: {
          "criterias": []
        }
      }

      params.map(item => {
        param.data.criterias.push({ id: item.id })
      })
      console.log(params)
      delProperty(param, res => {
        _this.$message.success("删除成功")
        _this.getMain()
      })
    },

    //保险合同
    guaranteeChange(data) {
      for (let key in data) {
        this.utilToKey(key, "insuranceNo", data, "InsuranceNum")
        if (key == "contractFile") {
          if (!!data[key]) {
            data[key] = [data[key]]
          }
        }
        this.utilToKey(key, "contractFile", data, "InsuranceFile")
      }
      //   tools.setItem(this.deviceType.code, this.main)
    },

    // 修改
    updateBusiness(data, change) {
      //   let param = {
      //     ProjId: this.mess.ProjId,
      //     secret: this.mess.secret,
      //     data: {
      //       criterias: []
      //     }
      //   };
      let param = []
      //生成对应修改数据
      data.map((item, index) => {
        let arr = change[index][1].split(".");
        let info = {};
        console.log(change[index][3], "change[index][3]")
        info[arr[1]] = change[index][3];
        param.push({
          FmId: item.id,
          Infos: info
        });
      });
      //   data.map((item, index) => {
      //     let arr = change[index][1].split(".");
      //     let info = {};
      //     info[arr[1]] = [{ value: change[index][3] }];
      //     param.data.criterias.push({
      //       id: item.id,
      //       infos: info
      //     });
      //   });
      //   //对五大厂商进行特殊处理
      param.map(item => {
        if (!!item.Infos.DPSupplierID) {
          item.Infos.DPSupplierID = item.Infos.DPSupplierID.split("-")[0]
        }
        if (!!item.Infos.DPManufacturerID) {
          item.Infos.DPManufacturerID = item.Infos.DPManufacturerID.split("-")[0]
        }
        if (!!item.Infos.DPInsurerID) {
          item.Infos.DPInsurerID = item.Infos.DPInsurerID.split("-")[0]
        }
        if (!!item.Infos.DPMaintainerID) {
          item.Infos.DPMaintainerID = item.Infos.DPMaintainerID.split("-")[0]
        }
        if (!!item.Infos.DPSpecificationID) {
          item.Infos.DPSpecificationID = item.Infos.DPSpecificationID.split("-")[0]
        }
        for (let k in item.Infos) {
          if (item.Infos[k] == "") {
            item.Infos[k] = null
          }
        }
        return item
      })
      upDateTableMain({
        ProjId: this.$route.query.projId,
        UserId: this.$route.query.userId
      }, param).then(res => {
        console.log(res)
      })
      //   updateProperty(param, res => {
      //   })
    },

    //获取到了正确的信息
    getInfors(infos, row) {
      //其他的开始判断
      let val = this.hot.colToProp(row.col);
      if (val == "caozuo") {
        this.iframeSrc =
          process.env.BASE_URL +
          ":8889/#/details?perjectId=" +
          this.$route.query.projId +
          "&secret=" +
          this.$route.query.secret +
          "&FmId=" +
          infos.id +
          "&type=1&code=" +
          infos.family;
        this.dialog.details = true
      }
      if (val == "infos.EquipQRCode") {
        this.qrcodeUrl = this.main[row.row].infos.EquipQRCode
        if (!!this.qrcodeUrl) {
          this.dialog.qrcode = true;
        } else {
          this.$message("此设备没有设备二维码")
        }
      }

      //   if (val == "infos.Brand" || val == "infos.Specification") {
      //     this.dialog.firm = true;
      //   }

      if (val == "infos.SupplierContractID") {
        let falg = null
        if (!!this.main[row.row].infos) {
          if (!!this.main[row.row].infos.DPSupplierID) {
            falg = this.main[row.row].infos.DPSupplierID.split("-")[0]
          }
        }
        if (!!falg) {
          this.id = falg
          this.dialog.supply = true;
        } else {
          this.$message("请先选择供应商")
        }
      }

      if (val == "infos.InsuranceNum") {
        //选择保单
        let falg = null
        if (!!this.main[row.row].infos) {
          if (!!this.main[row.row].infos.DPInsurerID) {
            falg = this.main[row.row].infos.DPInsurerID.split("-")[0]
          }
        }
        if (!!falg) {
          this.id = falg
          this.dialog.guarantee = true;
        } else {
          this.$message("请先选择保险商")
        }
      }

      if (val == "infos.InsuranceFile" || val == "infos.Archive" || val == "infos.CheckReport") {
        this.filesArr = this.main[row.row].infos ? (this.main[row.row].infos[val.split(".")[1]] ? [this.main[row.row].infos[val.split(".")[1]]] : []) : []
        this.dialog.uploadFiles = true
      }

      if (
        val == "infos.InstallPic" ||
        val == "infos.InstallDrawing" ||
        val == "infos.Nameplate" ||
        val == "infos.Drawing"
      ) {
        if (this.onlyRead) {
          this.dialog.lookPic = true
          this.picsArr = this.main[row.row].infos ? (this.main[row.row].infos[val.split(".")[1]] ? this.main[row.row].infos[val.split(".")[1]] : []) : []
        } else {
          this.imgsArr = this.main[row.row].infos ? (this.main[row.row].infos[val.split(".")[1]] ? this.main[row.row].infos[val.split(".")[1]] : []) : []
          this.dialog.uploadImgs = true
        }
      }

      if (val == "infos.DPManufacturerID") {
        this.dialog.firm = true;
      }

      if (val == "infos.Pic") {
        this.picsArr = this.main[row.row].infos ? (this.main[row.row].infos[val.split(".")[1]] ? this.main[row.row].infos[val.split(".")[1]] : []) : []
        if (this.onlyRead) {
          this.dialog.lookPic = true
        } else {
          this.dialog.pic = true
        }
      }

      //   if (
      //     val == "infos.Supplier"
      //   ) {
      //     this.dialog.supplier = true;
      //   }

      if (
        val == "infos.DPSupplierID"
      ) {
        this.dialog.supplier = true;
      }

      if (val == "infos.DPMaintainerID"
      ) {
        this.dialog.maintainer = true;
      }

      if (
        val == "infos.DPInsurerID"
      ) {
        this.dialog.insurer = true;
      }

      //   if (
      //     val == "infos.Supplier"
      //   ) {
      //     this.dialog.supplier = true;
      //   }

      //   if (val == "infos.Maintainer") {
      //     this.dialog.maintainer = true;
      //   }

      //   if (
      //     val == "infos.Insurer" ||
      //     val == "infos.InsurerContactor") {
      //     this.dialog.insurer = true;
      //   }
      this.row = row.row
      this.messKey = val
      console.log(val, row);
    },

    //获取被筛选掉的行号
    trimmedRows() {
      // var plugin = hot.getPlugin('trimRows').trimmedRows;//获取被筛选掉的行号
      var plugin = this.hot.getPlugin("trimRows").trimmedRows;
      let dataLength = this.main.length;
      let dataArr = new Array();
      for (let i = 0; i < dataLength; i++) {
        dataArr.push(i);
      }
      if (plugin.length <= 0) {
        dataArr = undefined;
      } else {
        dataArr = this.array_diff(dataArr, plugin);
      }
      return dataArr || [];
      // var DataArray = new Array();

      // for (var i = 0; i < plugin.length; i++) {
      //     // 通过行号获取数据
      //     DataArray.push(this.hot.getSourceDataAtRow(plugin[i]));
      // }
    },
    supplyChange(data) {
      let changeData = { id: data }
      this.utilToKey("id", "id", changeData, "SupplierContractID")
      //   tools.setItem(this.deviceType.code, this.main)
    },

    //保险合同
    guaranteeChange(data) {
      for (let key in data) {
        this.utilToKey(key, "insuranceNo", data, "InsuranceNum")
        if (key == "contractFile") {
          if (!!data[key]) {
            data[key] = [data[key]]
          }
        }
        this.utilToKey(key, "contractFile", data, "InsuranceFile")
      }
      //   tools.setItem(this.deviceType.code, this.main)
    },

    //选择型号修改
    firmChange(data) {
      for (let key in data) {
        // if (key == 'brand') {
        //   this.setDataToMain(data[key], "Brand", this.row)
        // }
        // if (key == 'name') {
        //   this.setDataToMain(data[key], "Specification", this.row)
        // }
        // if (key == 'venderName') {
        //   this.setDataToMain(data[key], "Manufacturer", this.row)
        // }
        // if (key == 'venderId') {
        //   this.setDataToMain(data[key], "DPManufacturerID", this.row)
        // }
        // if (key == 'specificationId') {
        //   this.setDataToMain(data[key], "DPSpecificationID", this.row)
        // }
        if (key == "venderId") {
          data[key] = data[key] + "-" + data.name + "/" + data.brand
          this.utilToKey(key, "venderId", data, "DPManufacturerID")
        }
        this.utilToKey(key, "specificationId", data, "DPSpecificationID")
      }
    },

    //如果选择供应商之后
    supplierChange(data) {
      for (let key in data) {
        if (key == "venderId") {
          data[key] = data[key] + "-" + data.name
          this.utilToKey(key, "venderId", data, "DPSupplierID")
        }
        // if (key == 'name') {
        //   this.setDataToMain(data[key], "Supplier", this.row)
        // }
        // if (key == 'email') {
        //   this.setDataToMain(data[key], "SupplierEmail", this.row)
        // }
        // if (key == 'website') {
        //   this.setDataToMain(data[key], "SupplierWeb", this.row)
        // }
        // if (key == 'phone') {
        //   this.setDataToMain(data[key], "SupplierPhone", this.row)
        // }
        // if (key == 'fox') {
        //   this.setDataToMain(data[key], "SupplierFax", this.row)
        // }
        // if (key == 'man') {
        //   this.setDataToMain(data[key], "SupplierContactor", this.row)
        // }
      }
      //   tools.setItem(this.deviceType.code, this.main)
    },

    //保险商变更
    changeInsurer(data) {
      for (let key in data) {
        // if (key == 'name') {
        //   this.setDataToMain(data[key], "Insurer", this.row)
        // }
        // if (key == 'email') {
        //   this.setDataToMain(data[key], "InsurerEmail", this.row)
        // }
        // if (key == 'website') {
        //   this.setDataToMain(data[key], "InsurerWeb", this.row)
        // }
        // if (key == 'phone') {
        //   this.setDataToMain(data[key], "InsurerPhone", this.row)
        // }
        // if (key == 'fox') {
        //   this.setDataToMain(data[key], "InsurerFax", this.row)
        // }
        // if (key == 'man') {
        //   this.setDataToMain(data[key], "InsurerContactor", this.row)
        // }
        if (key == "venderId") {
          data[key] = data[key] + "-" + data.name
          this.utilToKey(key, "venderId", data, "DPInsurerID")
        }
      }
      //   tools.setItem(this.deviceType.code, this.main)
    },

    //维修商变更
    changeMaintainer(data) {
      for (let key in data) {
        // if (key == 'name') {
        //   this.setDataToMain(data[key], "Maintainer", this.row)
        // }
        // if (key == 'email') {
        //   this.setDataToMain(data[key], "MaintainerEmail", this.row)
        // }
        // if (key == 'website') {
        //   this.setDataToMain(data[key], "MaintainerWeb", this.row)
        // }
        // if (key == 'phone') {
        //   this.setDataToMain(data[key], "MaintainerPhone", this.row)
        // }
        // if (key == 'fox') {
        //   this.setDataToMain(data[key], "MaintainerFax", this.row)
        // }
        // if (key == 'man') {
        //   this.setDataToMain(data[key], "MaintainerContactor", this.row)
        // }
        if (key == "venderId") {
          data[key] = data[key] + "-" + data.name
          this.utilToKey(key, "venderId", data, "DPMaintainerID")
        }
      }
      //   tools.setItem(this.deviceType.code, this.main)
    },

    utilToKey(key, name, data, messName) {
      if (key == name) {
        this.setDataToMain(data[key], messName, this.row)
      }
    },

    //上传文件弹窗触发事件
    fileChange(keys) {
      this.setDataToMain(keys[0], this.messKey.split(".")[1], this.row)
      //   tools.setItem(this.deviceType.code, this.main)
    },

    //上传图片弹窗触发事件
    imgChange(keys) {
      this.setDataToMain(keys[0], this.messKey.split(".")[1], this.row)
      //   tools.setItem(this.deviceType.code, this.main)
    },

    //设备图片弹窗改变事件
    changePics(keys) {
      this.setDataToMain(keys, this.messKey.split(".")[1], this.row)
      //   tools.setItem(this.deviceType.code, this.main)
    },

    //判断是否有值，有值赋值
    setDataToMain(data, key, row) {
      if (!!data && data != '--') {
        if (!!this.main[row].infos) {
          //falg确定每个的是否有值
          this.main[row].infos[key] = data
          this.updateBusiness([this.main[row]], [[0, "infos." + key, null, data]])

        } else {
          this.main[row].infos = {}
          this.main[row].infos[key] = data
        }
      } else {
        this.main[row].infos[key] = ''
      }
    }
  }
};
</script>
<style lang="less">
.hanson-bar {
  height: 40px;
  padding: 5px;
  font-size: 16px;
  overflow: hidden;
  .iconfont {
    font-size: 12px;
  }
  .el-button {
    margin-right: 10px;
  }
}
</style>
